<?php
session_start();
/*
 * cart.php - sessions are enabled
 *
 * Shopping Cart for Three Aces Pizza Shop  
 * Also a list of categories to return to a menu.
 *
 * Computer Science S-75
 * Diane Cook Donovan
 */

if (isset($_SESSION["cart"])) 
{
/* Pull out the shopping cart from the seesion */
  $cart=$_SESSION["cart"];
  $cart_count=$_SESSION["cart_count"];
}
?>	

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Project 0: Three Aces</title>
<link rel="stylesheet" href="TA_styles.css" />
<link rel="icon" type="image/ico" href="DCD.ico"/>
</head>

<body>
<!-- div wrapper wraps the entire page -->
<div id="wrapper">
<!-- div header is the title banner at the top of the page -->
<div id="header">
 <h1>Three Aces Eatery</h1>
</div>

<!-- div main contains categories list on left and whitespace area on the right -->
<div id="main">
<!-- div categories displays as a left nav bar listing the categories to select -->
<div id="categories"><ul>
<?php
$xml = simplexml_load_file("menu.xml");
foreach ($xml->category as $category)
{
  echo "<li><a href='index.php?type=" . $category["type"] . "'>";
  echo $category["type"] . "</a></li>";
  if (!isset($category_type)) $category_type=$category["type"];
}
?>
</ul></div>  <!-- categories -->

<!-- div whitespace is the main display area of the page -->
<div id="whitespace">
<?php
/* get posted values from global $_POST */
$order = $_POST["order"];
$item = @$_POST["item"];
$quantity = htmlspecialchars(@$_POST["quantity"]);
$i_size = htmlspecialchars(@$_POST["i_size"]);
$category_type = @$_POST["category_type"];
$item_count = @$_POST["item_count"];
		  
/* First add new items to cart or update the cart before diplaying its contents */
/* order is the value of the submit button */
switch ($order)
{
case "order":
/* First, check to make sure the POSTed info came from menu.xml */
/* Also, get description and price */
/* trim the excess chars from the posted strings */
  $category_type = trim($category_type);
  $item = trim($item);
  $i_size = trim($i_size);
  /* compare category type, item and size */
  $item_valid = FALSE;
  foreach ($xml->category as $x_category)
  {
    if ($x_category["type"] == $category_type)
    {
      foreach ($x_category->items->item as $x_item)
      {
        if ($x_item["name"] == $item)
        {
          $description = $x_item->description;
          foreach ($x_item->sizes->size as $x_size)
          {
            if ($x_size == $i_size)
            {
              $price = $x_size->price;
              $item_valid = TRUE;
            }
          }
        }
      }
    }
  }
  /* convert $price into a decimal */
  $price = 100 * "$price"/100;
  if ($item_valid == "TRUE")
  {
	/* check to make sure quantity is a valid integer */
    if ((!preg_match("/^(\d+)$/", $quantity, $matches)) || ($quantity < 1)) 
    {
      echo "<h3>Please enter a valid quantity!</h3>";
      /* if not valid present a form for customer to correct the info */
      echo "<b>" . $category_type . "</b><br />";
      echo $item . "<br />";
      echo "<i>" . $description . "</i><br />";
      echo $i_size . " \$" . $price . " each<br />";
?>
      <form method="post" action="cart.php">
      <input type="text" name="quantity" value="1" size="4" />
      <input type="hidden" name="category_type" value=" <?php echo $category_type; ?> " />
      <input type="hidden" name="i_size" value=" <?php echo $i_size; ?> " />
      <input type="hidden" name="item" value=" <?php echo $item; ?> " />
      <input type="submit" name="order" value="order" />
      </form><br />
<?php
    } else {
    /* Add the new item to the cart */
    /* Is there anything in the cart yet */
       if (!isset($_SESSION["cart_count"])) $cart_count=0;
       /* Is this particular item already in the cart */
      $item_added = FALSE;
	  /* check item, category and size for a match */
      for ($counter=0; $counter<$cart_count; $counter++) 
      {
        if (($cart["$counter"]["item"] == $item) && ($cart["$counter"]["category_type"] == $category_type) && ($cart["$counter"]["size"] == $i_size))
        {
        /* Found a match - update the quantity */
          $cart["$counter"]["quantity"] = $cart["$counter"]["quantity"] + $quantity;
          $item_added = TRUE;
        }
      }
      /* Add to cart only if it has not already been added */
      if(!$item_added)
      {
        $cart["$cart_count"]["price"] = $price;
        $cart["$cart_count"]["item"] = $item;
        $cart["$cart_count"]["quantity"] = $quantity;
        $cart["$cart_count"]["category_type"] = $category_type;
        $cart["$cart_count"]["size"] = $i_size;
        $cart_count++;
      }
    }
  }
break;

/* the update quantity button has been activated for a specific item - item_count - in the cart */
case "update quantity":
  /* Trim off the whitespace  */
  $item_count = trim($item_count);
  /* update the quantity only if quantity is a valid value */
  if ((preg_match("/^(\d+)$/", $quantity, $matches)) && ($quantity > 0)) 
  {
    $cart["$item_count"]["quantity"] = $quantity;
  }
break;

/* the delete item button has been clicked */
case "delete item":
  /* In order to delete an line item, everything after the item in the cart has to be moved up */
  $item_count = trim($item_count);
  /* But not if it's the only thing in the cart */
  if ($cart_count != 1)
  {
    for ($counter=$item_count; $counter<$cart_count; $counter++)
    {
      $next = $counter +1;
      $cart[$counter] = $cart["$next"];
    }
  }
  $cart_count = $cart_count - 1;
break;
}

/* Display cart if it is not empty */
/* the customer may have never put anything in the cart OR they deleted everything */
if ((!isset($cart_count)) || ($cart_count <= 0))
{
  echo "<h3>Your cart is empty.</h3>";
  $cart["0"]["category_type"] = "";
  $cart_count=0;

} else {
  echo "<h1>Your Three Aces Order</h1>";
  $Total_price = 0;
?>
  <table><tr><th>Category</th><th>Item</th><th>Quantity</th><th>Size</th><th>Unit Price</th><th>Total</th></tr>
<?php
  /* loop  through cart to display it */
  for ($counter=0; $counter<$cart_count; $counter++)
  {
    echo "<tr>";
    echo "<td>" . $cart["$counter"]["category_type"] . "</td>";
    echo "<td>" . $cart["$counter"]["item"] . "</td>";
?>
    <td>
    <!-- use a form to provide updating of the quantity for each item -->
    <form method="post" action="cart.php">
    <input type="text" name="quantity" value="<?php echo $cart["$counter"]["quantity"];?>" size="4" />
    </td><td>
<?php
    echo $cart["$counter"]["size"] . "</td>";
    echo "<td align=\"right\">\$";
	/* printf is used to format the price as currency */
	printf("%.2f\n", $cart["$counter"]["price"]); 
	echo " each</td>";
	$line_total = $cart["$counter"]["quantity"] * $cart["$counter"]["price"];
    echo "<td align=\"right\">\$";
    printf("%.2f\n", $line_total);
	echo "</td>";
    $Total_price = $Total_price + $line_total;
?>
    <td>
    <input type="hidden" name="item_count" value=" <?php echo $counter; ?>" />
    <input type="submit" name="order" value="update quantity" />
    </form>
    </td>
    <td>
    <!-- use a form to allow customer to delete each item -->
    <form method="post" action="cart.php">
    <input type="hidden" name="item_count" value=" <?php echo $counter; ?>" />
    <input type="submit" name="order" value="delete item" />
    </form>
    </td>
    </tr>
<?php
  }
?>
    <!-- print out the order total -->
    <tr><td colspan="3"></td><td colspan="3" align="right"><b>Order Total - $
<?php
    printf("%.2f\n", $Total_price);
?>
    </b></td><td></td><td></td></tr>
    <tr><td></td><td colspan="5">
    <!-- form for checkout collects customer name and phone number -->
    <form method="post" action="checkout.php">
    Enter Customer Name: <input type="text" name="customer" size="32" />
    </td><td colspan="2"></td>
    </tr>
    <tr><td></td><td colspan="5">
    Enter Phone Number: <input type="text" name="phone" size="32" />
    </td><td>
    <input type="submit" name="order" value="checkout" />
    </form>
    </td><td></td>
    </tr>
<?php
}
/* return $cart and $cart_)count to the session */
$_SESSION["cart"]=$cart;
$_SESSION["cart_count"]=$cart_count;
?>
</table>
</div>  <!-- whitespace -->
</div>  <!-- main -->
<!-- div footer displays info across the bottom of the page -->
<div id="footer">
<p>1613 Massachusetts Avenue - Cambridge - MA 02139</p>
<p>Between Mellen and Everett Streets</p>
</div>  <!-- footer -->
</div>  <!-- wrapper -->
</body>
</html>