<?php
session_start();
/*
 * cart.php - sessions are enabled 
 *
 * Checkout Cart for Three Aces Pizza Shop  
 * Also a list of categories to return to a menu.
 *
 * Computer Science S-75
 * Diane Cook Donovan
 */

if (isset($_SESSION["cart"])) 
{
/* Pull out the shopping cart from the session */
  $cart=$_SESSION["cart"];
  $cart_count=$_SESSION["cart_count"];
}
?>	

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" href="TA_styles.css" />
<link rel="icon" type="image/ico" href="DCD.ico"/>
<title>Project 0: Three Aces</title>
</head>

<body>
<!-- div wrapper wraps the entire page -->
<div id="wrapper">
<!-- div header is the title banner at the top of the page -->
<div id="header">
 <h1>Three Aces Eatery</h1>
</div>

<!-- div main contains categories list on left and whitespace area on the right -->
<div id="main">
<!-- div categories displays as a left nav bar listing the categories to select -->
<div id="categories"><ul>
<?php
$xml = simplexml_load_file("menu.xml");
foreach ($xml->category as $category)
{
  echo "<li><a href='index.php?type=" . $category["type"] . "'>";
  echo $category["type"] . "</a></li>";
  /* set the default $category_type to the first category for displaying a menu */
  if (!isset($category_type)) $category_type=$category["type"];
}
?>
</ul></div>  <!-- categories -->

<!-- div whitespace is the main display area of the page -->
<div id="whitespace">
<?php
/* Display cart if it is not empty */
if ((!isset($cart_count)) || ($cart_count <= 0))
{
  echo "<h3>Your cart is empty.</h3>";
} else {
/* check customer name and phone number for validity */	
  $customer = htmlspecialchars(@$_POST["customer"]);
  $phone = htmlspecialchars(@$_POST["phone"]);
  $phone = preg_replace("/[^\d]/", "", $phone);
  preg_match("/^(\d{3})(\d{3})(\d{4})$/", $phone, $matches);
  $phone = $matches[1] . "-" . $matches[2] . "-" . $matches[3];
  if ((!preg_match("/^([\w\x20]+)$/", $customer, $matches)))
  {
/* if bad customer name come back here and ask for it again with a form */	
    echo "<h3>Please enter a valid customer name and phone number.</h3>";
?>
    <form method="post" action="checkout.php">
    <p>Enter Customer Name: <input type="text" name="customer" size="32" /></p>
    <p>Enter Phone Number: <input type="text" name="phone" value=" <?php echo $phone; ?>" size="32" />
    <input type="submit" name="order" value="checkout" /></p>
    </form>
<?php
  } else {
/* okay, the cart has stuff in it and you have entered a valid customer name */		  
  echo "<h1>Your Three Aces Order</h1>";
  $Total_price = 0;
?>
  <table><tr><th>Category</th><th>Item</th><th>Quantity</th><th>Size</th><th>Unit Price</th><th>Total</th></tr>
<?php
/* Loop through the cart to display the customers order */
  for ($counter=0; $counter<$cart_count; $counter++)
  {
    echo "<tr>";
    echo "<td>" . $cart[$counter]["category_type"] . "</td>";
    echo "<td>" . $cart[$counter]["item"] . "</td>";
    echo "<td>" . $cart[$counter]["quantity"] . "</td>";
    echo "<td>" . $cart[$counter]["size"] . "</td>";
    echo "<td align=\"right\">\$";
    /* printf is used toformat the price as currency */
    printf("%.2f\n", $cart[$counter]["price"]);
    echo " each</td>";
    $line_total = $cart[$counter]["quantity"] * $cart[$counter]["price"];
    echo "<td align=\"right\">\$";
    printf("%.2f\n", $line_total);
    echo " </td></tr>";
    $Total_price = $Total_price + $line_total;
  }
  echo "<tr><td colspan=\"4\"><h2>Thank you, " . htmlspecialchars(@$_POST["customer"]) ."</h2> You order will be ready in 30 minutes.";
  if ($phone != "--") echo "<br />Phone: " . $phone;
  echo "</td><td><b>TOTAL</td><td>\$";
  printf("%.2f\n", $Total_price);
  echo "</b></td></tr></table>";
  /* empty out the cart */
  session_destroy();
  }
}
?>

</div>  <!-- whitespace -->
</div>  <!-- main -->
<!-- div footer displays info across the bottom of the page -->
<div id="footer">
<p>1613 Massachusetts Avenue - Cambridge - MA 02139</p>
<p>Between Mellen and Everett Streets</p>
</div>  <!-- footer -->
</div>  <!-- wrapper -->
</body>
</html>