<?php
session_start();
/*
 * index.php - sessions are enabled
 *
 * Home Page for Three Aces Pizza Shop with 
 * a list of categories and the menu from one of the categories.
 *
 * Computer Science S-75
 * Diane Cook Donovan
 */
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Project 0: Three Aces</title>
<link rel="stylesheet" href="TA_styles.css" />
<link rel="icon" type="image/ico" href="DCD.ico"/>
</head>

<body>
<!-- div wrapper wraps the entire page -->
<div id="wrapper">
<!-- div header is the title banner at the top of the page -->
<div id="header">
 <h1>Three Aces Eatery</h1>
</div>

<!-- div main contains categories list on left and whitespace area on the right -->
<div id="main">
<!-- div categories displays as a left nav bar listing the categories to select -->
<div id="categories"><ul>
<?php
$xml = simplexml_load_file("menu.xml");
foreach ($xml->category as $category)
{
  echo "<li><a href='index.php?type=" . $category["type"] . "'>";
  echo $category["type"] . "</a></li>";
  /* set the default $category_type to the first category for displaying a menu */
  if (!isset($category_type)) $category_type=$category["type"];
}
?>
</ul></div>  <!-- categories -->

<!-- div whitespace is the main display area of the page -->
<div id="whitespace">

<?php
if (isset($_GET["type"]))
/* make sure the category type entered at the url is in the XML menu */
{
  $typ = $_GET["type"];
  $results = $xml->xpath("category[@type='$typ']");
  if (!empty($results)) $category_type = $_GET["type"];
}
foreach ($xml->category as $category)
{
  if ($category["type"] == $category_type)
  {
	/* display category name at as title */
    echo "<h1>" . $category["type"] . "</h1><table>";
    /* display each item in the cart in a table */
    foreach ($category->items->item as $item)
    {
      echo "<tr>";
      echo "<td>" . $item["name"] . "<br /><i>" . $item->description . "</i></td>";
      foreach ($item->sizes->size as $i_size)
      {
        echo "<td>" . $i_size . "</td>";
        echo "<td>" . "$" . $i_size->price . "</td>";
?>
        <td>
        <!-- each row in the table is an individual form for adding an item to the cart at cart.php -->
        <form method="post" action="cart.php">
        <input type="text" name="quantity" value="1" size="4" />
        <input type="hidden" name="category_type" value=" <?php echo $category_type; ?> " />
        <input type="hidden" name="i_size" value=" <?php echo $i_size; ?> " />
        <input type="hidden" name="item" value=" <?php echo $item["name"]; ?> " />
        <input type="submit" name="order" value="order" />
        </form>
        </td>
<?php
      }
      echo "</tr>";
    }
  }
}
?>
<tr><td colspan="3"></td><td>
<form method="post" action="cart.php">
<input type="submit" name="order" value="View Cart" />
</form>
</td></tr>
</table>
</div>  <!-- whitespace -->
</div>  <!-- main -->

<!-- div footer displays info across the bottom of the page -->
<div id="footer">
<p>1613 Massachusetts Avenue - Cambridge - MA 02139</p>
<p>Between Mellen and Everett Streets</p>
</div>  <!-- footer -->
</div>  <!-- wrapper -->
</body>
</html>